.TH AutoFTP 1L "GPL Internet Utilities" "FSF" \" -*- nroff -*-
.SH NAME
AutoFTP \- automatically download files by ftp connection
.SH SYNOPSIS
.B AutoFTP
[address path <options>]
.br
.B AutoFTP
{\-help}
.SH DESCRIPTION
This manual page
documents the GPL version of
.BR AutoFTP .

.B AutoFTP
automatically download files by ftp connection. This is very usefull when
updating your Linux release downloading from the Internet, or when you
want to download all files in a directory without user activity.
.SS OPTIONS
When GPL
.B autoftp
is invoked with less than 2 arguments, an error line shows. The list of 
commands of this program is:

.TP
.I "\-help"
Print a usage message on standard output and exit successfully.
.TP
.I "<address>"
Is needed to know the server to connect to.
.TP
.I "<path>"
Is needed to know where are the files to download.
.TP
.I "-u<username>"
Is used to specify other username than anonymous (default is anonymous)
.TP
.I "-p<password>"
Is used to specify other password than user e-mail
.TP
.I "-n<1-100>"
Is used to specify the download priority. Useful when you are downloading
with a modem and want to do another download at the same time.
.TP
.I "-mirror"
Is used to make mirrors of another site, it creates a file called .AutoFTP
where it stores the log.
.TP
.I "-ignoredate"
Is used to make mirrors of another site, but ignoring the timestamp of the
files, not using it to determine if the file is older o newer.
.TP
.I "-ignoresize"
If a file isn't downloaded at all, 
.B
AutoFTP 
try to resume it, but if you have
files that was downloaded right, and on the source ftp server they are
updated and the size change, 
.B
AutoFTP 
tries to download it checking for a
small piece of data making a CRC of the start and the end of both files, if
they differ then the file is downloaded complete, but if you use this flag
you may force 
.B
AutoFTP 
to continue the file.
.TP
.I "-x <param1> [param2]"
Is used to ignore files/directories that matches with param. You can use
wildcards like * and ?.
.TP
.I "-i <param1> [param2]"
Is used to only download files/directories that matches with param. You can
use widlcards like * and ?.
.TP
.I "-nogzip"
You can use this flag to tell 
.B
AutoFTP 
not to use file compression.
Compressing files before download may speed up the downloading process but
make the server work for compress the files, and your machine to uncompress
them; on pentium machines this isn't a big trouble, if you can hear mp3 and
work with netscape then you machine is fast enough to use gzip compression.
.TP
.I "-delete"
Used to delete files on the SOURCE after they were downloaded good.

.SS RUNNING COMMANDS

.TP
.I "Ctrl-C"
Is used to change priority without stopping the current download. It can be
used to exit the program.

.SS EXAMPLES

.B autoftp
123.1.1.2 /pub

.B autoftp
sunsite.unc.edu /pub/Linux/distributions/slackware

.B autoftp
ftp.cdrom.com /pub/linux/slackware -n50

.B autoftp
sunsite.unc.edu /pub/Linux/distributions -x debian redhat

.B autoftp
my.ip.address /home/myself -umyself -pmypassword -x dir01 dir02 file01

.B autoftp
my.ip.address /home/myself -i dir0* -ignoredate -ignoresize

.B autoftp
my.ip.address /home/myself -delete -nogzip

.SS BUGS
There is a bug when the file to download is a symbolic link, therefor, 
.B AutoFTP
ignore all symbolic links.
Also i have a bug, sometimes it "download" a file called Linux, but i don't
know how that word comes into the memory of the software... if you can find
it, please let me know.


.SS AUTHOR
.B AutoFTP
was designed and programmed by Mario Medina in Mexico, if you want to talk
with he send a e-mail to:
.TP
.I "Mario Medina <medisoft@masago.com.mx>"
.TP
.I "Mario Medina <medisoft@ditec.com.mx>"
.TP
.I "Mario Medina <medisoft@mail.alohabbs.org.mx>"
.TP
.I "Mario Medina <medisoft@medisoft.alohabbs.org.mx>"

.TP
Homepage of Mario Medina is:

.TP
.I "http://medisoft.alohabbs.org.mx"
.TP
.I "http://masago.com.mx/~medisoft"

.SS 

.SS SEE ALSO
.BR ftp (1)
.BR ncftp (1)
.BR mir (1)

.TP
.I ""


