#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <arpa/telnet.h>
#include <netdb.h>

#include <sys/signal.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>

#ifdef DEBUG
#undef DEBUG
#endif

#include "mversion.h"

#define PENDENT  0
#define UNFINISH 1
#define READY    2
#define IGNORED  4
#define BADLINK  8




#define MAXBAD 2
struct LINK {
  char *ptrAddress;
  char *ptrPath;
  char *ptrFile;
  unsigned long lSize;
  unsigned long lPos;
  int iStatus;
  int iPort;
};

// Extensiones de archivos conocidos, los que no esten aqui pueden ser
// tomados como directorios, no como archivos. DEBE terminar en NULL
char *strValidExt[] = 
{ "html", "htm", "gif", "jpg", "avi", "mpg", "mpeg", "zip", "lzh", "shtml",
  "shtm", "au", "wav", "voc", "mid", "mp3", "mp2", "mpe", "exe", "com",
  "jpeg", "jpe", "pcx", "bmp", "tif", "tiff", "ra", "ram", "viv", "mov", 
  "qt", "gz", "bz2", "Z", "lzh", "sit",
  NULL
};

// Variables globales
// DEBUG maximo = 3

//int obtuvo=0;
int QUIET=0, DEBUG=2, PAUSA=0, RESTRICTDIR=1, RESTRICTSITE=1;
int REBUILD=0, RANDOM=0, INITFILTER=1, ONLYASCII=1, LYNXOK=1;
int CHECKALL=0, EXPORT=0;
char USER[32],PASS[32];
char **ptrExcludeList;
char *ptrAnterior, *ptrSiguiente;
unsigned long lTotFiles, lDownFiles;
int ProgramStat=0;

// Declaracion de funciones
long fnSearchInDB(struct LINK **, struct LINK *, long);
//unsigned long fnGetSize(struct LINK **, struct LINK *);
long fnGetSize(char *);
int fnTestLynx(void);
int fnSaveListHistory(struct LINK **, int);

void Terminar(void) { ProgramStat=1; }


// Para determinar si es un caracter que pueda ir en un html
int isvalidhtmlchr(int c)
{
  unsigned char cValidChr[] = 
  { 9, 10, 13, ' ', '', '', '', '', '', '', '', 
   '', '', '', '', '', '', '', '', '', '', '',
   '', '', '', '', '', '', 0 };
  int i;
  for(i=0;cValidChr[i]!=0;i++) if(cValidChr[i]==(unsigned char)c) return 1;
  if(isalpha(c)||isdigit(c)||ispunct(c)) return 1;
  if(isprint(c)) return 1;
}
// Para convertir a minusculas 
char *strlwr(char *str)
{
  char *ret;
  int i;
  if(str==NULL) return str;
  ret=(char *)malloc(strlen(str)+1);
  for(i=0;i<strlen(str);i++) ret[i]=tolower(str[i]);
  ret[i]=0;
  return ret;
}

int _ALARMA(void) { if(DEBUG>=1) printf("\nServidor no contesta\n"); return 1; }

int haveascii(char *src)
{
  int i;
  for(i=0;i<strlen(src);i++) if(src[i]<32) return 1;
  return 0;
}
// Para eliminar caracteres invalidos de los nombres de archivo
char *FIXNAMES(char *src)
{
  char *des=(char *)malloc(strlen(src)+1);
  int i,o=0;
  for(i=0;i<strlen(src);i++)
    switch(src[i]) {
      case '~': des[i]='_'; break;
      case '?': des[i]='_'; break;
      default: if(src[i]>=32) des[i-o]=src[i]; else o++;
    }
  while(des[strlen(des)-1]=='/') des[strlen(des)-1]=0;
  des[strlen(src)]=0;
  return des;
}
// Para eliminar caracteres invalidos de los nombres de archivo, hasta diagonales
char *FIXNAMES2(char *src)
{
  char *des=(char *)malloc(strlen(src)+1);
  int i,o=0;
  for(i=0;i<strlen(src);i++)
    switch(src[i]) {
      case '~': des[i]='_'; break;
      case '?': des[i]='_'; break;
      case '/': des[i]='.'; break;
      default: if(src[i]>=32) des[i-o]=src[i]; else o++;
    }
  while(des[strlen(des)-1]=='/') des[strlen(des)-1]=0;
  des[strlen(src)]=0;
  return des;
}
 
// Para crear todos los directorios necesarios en una sola linea
// de path       
int MKDIR(char *src)
{
  char *tmp=(char *)malloc(strlen(src)+1);
  int i;

  for(i=0;i<strlen(src);i++) {
    if(src[i]!='/') {
      tmp[i]=src[i];
      tmp[i+1]=0;
    } else {
      if(strrchr(tmp,'/')!=NULL)
        if(!strcmp(strrchr(tmp,'/'),"/..") || !strcmp(strrchr(tmp,'/'),"/.")) return 0;
      if(mkdir(tmp,00777)!=-1)
        if(!QUIET) printf("Creando directorio [%s]\n",tmp);
      tmp[i]=src[i];
      tmp[i+1]=0;
    }
  }
  if(mkdir(src,00777)!=-1)
    if(!QUIET) printf("Creando directorio [%s]\n",tmp);
  return 1;
}

struct LINK *fnGetAddress(char *link)
{
  int i, INI, FIN;
  char *ptrTmp=(char *)malloc(strlen(link)+2);
  struct LINK *liga;

  if(!QUIET) if(DEBUG>0) fprintf(stderr,"Parsing: [%s] ",link);  
  
  // Inicializa a la lista de ligas
  liga=(struct LINK *)malloc(sizeof(struct LINK));
  liga->ptrAddress=liga->ptrPath=liga->ptrFile=NULL;
  strcpy(ptrTmp,link);
  
  // Remueve el http:// si es que existe
  if(!strncmp(strlwr(ptrTmp),"http://",7))
    strcpy(ptrTmp,(ptrTmp+7));
    
  // Busca lo primero que sea una liga (que sea letra o numero)
  for(INI=0;INI<strlen(ptrTmp)&&!isalpha(ptrTmp[INI])&&!isdigit(ptrTmp[INI]);INI++);
  for(FIN=INI+1;FIN<strlen(ptrTmp) && 
                (isalpha(ptrTmp[FIN]) || isdigit(ptrTmp[FIN]) || ptrTmp[FIN]=='.' ||
                 ptrTmp[FIN]=='-');FIN++);
  liga->ptrAddress=(char *)malloc(FIN-INI+2);
  if(liga->ptrAddress==NULL) {
    perror("No hay suficiente memoria\n");
    exit(0);
  }
  bzero(liga->ptrAddress,FIN-INI+1);
  strncpy(liga->ptrAddress,(ptrTmp+INI),FIN-INI);
  
  
  // Busca el path
  if(FIN+1>=strlen(ptrTmp)) {
    liga->ptrPath=(char *)malloc(2);  
    liga->ptrFile=NULL;
    strcpy(liga->ptrPath,"");
  } else { 
    if(strrchr((ptrTmp+FIN+1),'/')==NULL) {
      if(strrchr((ptrTmp+FIN+1),'.')!=NULL) {
        for(i=0;strValidExt[i]!=NULL;i++)
          if(!strcmp(strValidExt[i],strlwr(strrchr((ptrTmp+FIN+1),'.')+1))) break;
      } else {
        for(i=0;strValidExt[i]!=NULL;i++);
      }
      if(strValidExt[i]==NULL) {
        liga->ptrPath=(char *)malloc(strlen(ptrTmp)-FIN+1);  
        strcpy(liga->ptrPath,(ptrTmp+FIN+1));
        liga->ptrFile=NULL;
      } else {
        if(DEBUG>=1) fprintf(stderr,"Archivo de tipo %s\n",strValidExt[i]);
        liga->ptrPath=(char *)malloc(3);  
        strcpy(liga->ptrPath,"");
        liga->ptrFile=(char *)malloc(strlen(ptrTmp)-FIN+2);
        strcpy(liga->ptrFile,(ptrTmp+FIN+1));
      }
    } else {
      INI=FIN+1;
      for(FIN=strlen(ptrTmp);FIN>INI && ptrTmp[FIN]!='/';FIN--);
      liga->ptrPath=(char *)malloc(FIN-INI+2);
      bzero(liga->ptrPath,FIN-INI+1);
      strncpy(liga->ptrPath,(ptrTmp+INI),FIN-INI);
      // Extrae el archivo
      if(FIN+1>=strlen(ptrTmp)) {
        liga->ptrFile=NULL;
      } else {
        liga->ptrFile=(char *)malloc(strlen(ptrTmp)-FIN+2);
        bzero(liga->ptrFile,strlen(ptrTmp)-FIN+2); // Medisoft
        strcpy(liga->ptrFile,(ptrTmp+FIN+1));
      }
    }
  }
  liga->iStatus=PENDENT;
  return liga;
}

struct LINK **fnGetMainAddress(struct LINK **liga, char *link)
{
  int i, INI, FIN, iLinkNumber=0;
  char *ptrTmp=(char *)malloc(strlen(link)+2);
  struct LINK *ptrTmpLink;

  
  // Inicializa a la lista de ligas
  ptrTmpLink=fnGetAddress(link);
  if(fnSearchInDB(liga,ptrTmpLink,0)<0) {
    if(!QUIET) fprintf(stderr,"%cAdding: \n",0x0d);
    if(liga==NULL) {
      liga=(void *)malloc(sizeof(void *)*2);
      if(liga==NULL) {
        perror("No hay suficiente memoria");
        exit(1);
      }
    } else {
      for(iLinkNumber=0;liga[iLinkNumber]!=NULL;iLinkNumber++);
      liga=(void *)realloc(liga,sizeof(void *)*(iLinkNumber+2));
      if(liga==NULL) {
        perror("No hay suficiente memoria");
        exit(1);
      }
    }
    liga[iLinkNumber]=ptrTmpLink; 
    liga[iLinkNumber+1]=NULL;
    lTotFiles++;
  } else {
    if(!QUIET) printf("\x0d                                                                               \x0d");
    if(DEBUG>=1) printf("Ya esta en la base el de %s/%s/%s\n",ptrTmpLink->ptrAddress,ptrTmpLink->ptrPath,ptrTmpLink->ptrFile);

    if(ptrTmpLink->ptrAddress!=NULL) free(ptrTmpLink->ptrAddress);
    if(ptrTmpLink->ptrPath!=NULL)    free(ptrTmpLink->ptrPath);
    if(ptrTmpLink->ptrFile!=NULL)
      free(ptrTmpLink->ptrFile);
    if(ptrTmpLink!=NULL) free(ptrTmpLink);
//    liga[iLinkNumber]=NULL;
  }
//  liga[iLinkNumber+1]=NULL;
  return liga;
}


struct LINK **fnAddLinkToList(struct LINK **lnkLinks, char *strLink, char *ptrCWD)
{
  int i;
  char *tmplink, *link;
  char *strInvalidPorts[] = { "ftp:", "mailto:", "telnet:", "..", "#", NULL };
                         
  link=(char *)malloc(strlen(strLink)+2);
  bzero(link,strlen(strLink)+2);
  strcpy(link,strLink); 
  // Verifica que sea algo de http, si no se sale
  for(i=0;strInvalidPorts[i]!=NULL;i++)
    if(!strncmp(link,strInvalidPorts[i],strlen(strInvalidPorts[i])))
      return lnkLinks;
  if(strchr(link,'?')!=NULL) return lnkLinks;

  // Checa si no es un link completo con todo y direccion
  if(strncmp(link,"http://",7)) {
    // Verifica si es un archivo o un directorio
    if(strrchr(link,'.')==NULL) {
      // Es directorio, si no tiene diagonal al final, ponsela
      if(link[strlen(link)-1]!='/') {
        link=(char *)realloc(link,strlen(link)+3);
        strcat(link,"/");
      }
      // Si no trae indicacion de su origen el el path, ponle el actual
      if(link[0]!='/') {
        char *tmp=malloc(strlen(link)+strlen(ptrCWD)+3);
        bzero(tmp,strlen(link)+strlen(ptrCWD)+1);
        sprintf(tmp,"%s/%s",ptrCWD,link);
        link=tmp;
        if(DEBUG>=1) printf("PuseD1: [%s]\n",link);
        if(DEBUG>=3) getchar();
      }
    } else {
      char *ext=strlwr((strrchr(link,'.')+1));
      // Revisa si es una extension conocida, si no puede ser directorio
      for(i=0;strValidExt[i]!=NULL;i++)
        if(!strcmp(strValidExt[i],ext)) break;
      if(strValidExt[i]==NULL) {
        if(DEBUG>=1) printf("Fue [%s] desde [%s]\n",ext,link);
       // Es directorio, si no tiene diagonal al final, ponsela
        if(link[strlen(link)-1]!='/') {
          link=(char *)realloc(link,strlen(link)+3);
          strcat(link,"/");
          if(link[0]!='/') {
            char *tmp=malloc(strlen(link)+strlen(ptrCWD)+3);
            bzero(tmp,strlen(link)+strlen(ptrCWD)+1);
            sprintf(tmp,"%s/%s",ptrCWD,link);
            link=tmp;
            if(DEBUG>=1) printf("PuseD2: [%s]\n",link);
            if(DEBUG>=3) getchar();
          }
        }
      } else {
      // Entonces, como la conozco, puede ser archivo, le agrego la ruta
      // hay que agregar soporte para directorio actual
        if(DEBUG>=1) printf("Extension(Type): %s\n",strValidExt[i]);
        if(link[0]!='/') {
          char *tmp=malloc(strlen(link)+strlen(ptrCWD)+3);
          bzero(tmp,strlen(link)+strlen(ptrCWD)+1);
          sprintf(tmp,"%s/%s",ptrCWD,link);
          link=tmp;
          if(DEBUG>=1) printf("PuseA: [%s]\n",link);
          if(DEBUG>=3) getchar();
        }
      }
    }
  }
    
  // Verifica que tenga direccion al principio, si no la tiene se la agrega    
  for(i=0;i<strlen(link)&&link[i]!='/';i++);
  if(i==0||strchr(link,'/')==NULL||strncmp(link,"http://",7)) {
    tmplink=(char *)malloc(strlen(link)+strlen(lnkLinks[0]->ptrAddress)+2);
    if(link[0]!='/')
      sprintf(tmplink,"%s/%s",lnkLinks[0]->ptrAddress,link);
    else
      sprintf(tmplink,"%s%s",lnkLinks[0]->ptrAddress,link);
    return fnGetMainAddress(lnkLinks, tmplink);
  } else
    return fnGetMainAddress(lnkLinks, link);
}


int Fgetc(FILE *fp)
{
  int k;
  k=fgetc(fp);
  if(k>=32&&DEBUG>=2) putchar(k), fflush(stdout);
  return k;
}


int fnExport(struct LINK **lnkLinks)
{
  unsigned long i,lSize;
/*struct LINK {
  char *ptrAddress;
  char *ptrPath;
  char *ptrFile;
  unsigned long lSize;
  unsigned long lPos;
  int iStatus;
  int iPort;
};
*/
  for(i=0;lnkLinks[i]!=NULL;i++) {
    printf("%s\t%s\t%s\t%lu\t%lu\t%u\t%u\n",
      lnkLinks[i]->ptrAddress,
      lnkLinks[i]->ptrPath,
      lnkLinks[i]->ptrFile,
      lnkLinks[i]->lSize,
      lnkLinks[i]->lPos,
      lnkLinks[i]->iStatus,
      lnkLinks[i]->iPort);
  }
}


struct LINK **fnImport(struct LINK **lnkLinks)
{
  unsigned long i,lSize,lPos;
//  struct LINK **lnkLinks=NULL;
  char buf[8192], *addr=NULL, *path=NULL, *file=NULL;
  int j,k,iStatus,iPort;

  for(j=0;lnkLinks[j]!=NULL;j++);
  printf("Importando\n");
  while(fgets(buf,sizeof(buf),stdin)) {
    addr=(char *)realloc(addr,strlen(buf));
    path=(char *)realloc(path,strlen(buf));
    file=(char *)realloc(file,strlen(buf));
    sscanf(buf,"%s%s%s%lu%lu%u%u",addr,path,file,&lSize,&lPos,&iStatus,&iPort);
    lnkLinks=(void *)realloc(lnkLinks,sizeof(void *)*(j+1));
    lnkLinks[j]=(struct LINK *)malloc(sizeof(struct LINK));

    if(strcmp(addr,"(null)")) {
      lnkLinks[j]->ptrAddress=(char *)malloc(strlen(addr)+1);
      strcpy(lnkLinks[j]->ptrAddress,addr);
    } else lnkLinks[j]->ptrAddress=NULL;
    
    if(strcmp(path,"(null)")) {
      lnkLinks[j]->ptrPath=(char *)malloc(strlen(path)+1);
      strcpy(lnkLinks[j]->ptrPath,path);
    } else lnkLinks[j]->ptrPath=NULL;
    
    if(strcmp(file,"(null)")) {
      lnkLinks[j]->ptrFile=(char *)malloc(strlen(file)+1);
      strcpy(lnkLinks[j]->ptrFile,file);
    } else lnkLinks[j]->ptrFile=NULL;
    lnkLinks[j]->lSize=lSize;
    lnkLinks[j]->lPos=lPos;
    lnkLinks[j]->iStatus=iStatus;
    lnkLinks[j]->iPort=iPort;
    j++;
  }
  lnkLinks[j]=NULL;
  return lnkLinks;
}



int fnSaveList(struct LINK **lnkLinks)
{
  FILE *fpArch;
  char strArch[2048],strArchBak[2048];
  unsigned long i,lSize;
  unsigned long ret;
  if(!EXPORT) fnSaveListHistory(lnkLinks,4);
  if(!QUIET) fprintf(stderr,"Salvando lista\n");
  sprintf(strArch,"%s/%s_mir.list",lnkLinks[0]->ptrAddress,FIXNAMES2(lnkLinks[0]->ptrPath));
  if(EXPORT) printf("%s\n",strArch);
  strcpy(strArchBak,strArch);
  strcat(strArchBak,".bak");
  unlink(strArchBak);
  rename(strArch,strArchBak);
  if((fpArch=fopen(strArch,"wb"))==NULL) { perror("fopen"); return -1; }
  // Salva los datos de la estructura: tamanio<dato>tamanio<dato>
  for(i=0;lnkLinks[i]!=NULL;i++) {
    // Guarda la direccion
    lSize=strlen(lnkLinks[i]->ptrAddress);
    fwrite((void *)&lSize,1,sizeof(unsigned long),fpArch);
    fwrite(lnkLinks[i]->ptrAddress,1,lSize,fpArch);
    // Guarda el path
    if(lnkLinks[i]->ptrPath==NULL) 
      lSize=0;
    else
      lSize=strlen(lnkLinks[i]->ptrPath);
    fwrite((void *)&lSize,1,sizeof(unsigned long),fpArch);
    if(lSize>0)
      fwrite(lnkLinks[i]->ptrPath,1,lSize,fpArch);
    // Guarda el archivo
    if(lnkLinks[i]->ptrFile==NULL) 
      lSize=0;
    else
      lSize=strlen(lnkLinks[i]->ptrFile);
    fwrite((void *)&lSize,1,sizeof(unsigned long),fpArch);
    if(lSize>0)
      fwrite(lnkLinks[i]->ptrFile,1,lSize,fpArch);
    // Guarda el tamanio
    fwrite((void *)&lnkLinks[i]->lSize,1,sizeof(unsigned long),fpArch);
    // Guarda la posicion
    fwrite((void *)&lnkLinks[i]->lPos,1,sizeof(unsigned long),fpArch);
    // Guarda el estatus
    ret=fwrite((void *)&lnkLinks[i]->iStatus,1,sizeof(int),fpArch);
    if(ret!=sizeof(int)) {
      perror("fwrite:dfull");
      fclose(fpArch);
      unlink(strArch);
      rename(strArchBak,strArch);
      exit(0);
    }
  }
  fclose(fpArch);
  if(ProgramStat==1) printf("\nSIGTERM recibido\n"), exit(0);
}


int fnSaveListHistory(struct LINK **lnkLinks, int max)
{
  FILE *fpArch;
  char strArch[2048],strArchBak[2048];
  unsigned long i,lSize;
  int iFN;
  if(!QUIET) fprintf(stderr,"Salvando history\n");
  sprintf(strArch,"%s/%s_mir.count",lnkLinks[0]->ptrAddress,FIXNAMES2(lnkLinks[0]->ptrPath));
  if((fpArch=fopen(strArch,"r+b"))==NULL) {
    if((fpArch=fopen(strArch,"wb"))==NULL) return 1;
    iFN=0;
    fprintf(fpArch,"%u\n",iFN);
    fclose(fpArch);
  } else {
    fscanf(fpArch,"%u",&iFN);
    iFN++;
    if(iFN>max||iFN<0) iFN=0;
    rewind(fpArch);
    fprintf(fpArch,"%u\n",iFN);
    fclose(fpArch);
  }
  
  sprintf(strArch,"%s/%s_mir%u.hist",lnkLinks[0]->ptrAddress,FIXNAMES2(lnkLinks[0]->ptrPath),iFN);
  strcpy(strArchBak,strArch);
  strcat(strArchBak,".bak");
  unlink(strArchBak);
  rename(strArch,strArchBak);
  if((fpArch=fopen(strArch,"wb"))==NULL) { perror("fopen"); return -1; }
  // Salva los datos de la estructura: tamanio<dato>tamanio<dato>
  for(i=0;lnkLinks[i]!=NULL;i++) {
    // Guarda la direccion
    lSize=strlen(lnkLinks[i]->ptrAddress);
    fwrite((void *)&lSize,1,sizeof(unsigned long),fpArch);
    fwrite(lnkLinks[i]->ptrAddress,1,lSize,fpArch);
    // Guarda el path
    if(lnkLinks[i]->ptrPath==NULL)
      lSize=0;
    else
      lSize=strlen(lnkLinks[i]->ptrPath);
    fwrite((void *)&lSize,1,sizeof(unsigned long),fpArch);
    if(lSize>0)
      fwrite(lnkLinks[i]->ptrPath,1,lSize,fpArch);
    // Guarda el archivo
    if(lnkLinks[i]->ptrFile==NULL) 
      lSize=0;
    else
      lSize=strlen(lnkLinks[i]->ptrFile);
    fwrite((void *)&lSize,1,sizeof(unsigned long),fpArch);
    if(lSize>0)
      fwrite(lnkLinks[i]->ptrFile,1,lSize,fpArch);
    // Guarda el tamanio
    fwrite((void *)&lnkLinks[i]->lSize,1,sizeof(unsigned long),fpArch);
    // Guarda la posicion
    fwrite((void *)&lnkLinks[i]->lPos,1,sizeof(unsigned long),fpArch);
    // Guarda el estatus
    fwrite((void *)&lnkLinks[i]->iStatus,1,sizeof(int),fpArch);
  }
  fclose(fpArch);
  //if(ProgramStat==1) printf("\nSIGTERM recibido\n"), exit(0);
}


long fnSearchInDB(struct LINK **lnkLinks, struct LINK *liga, long iMatch)
{
  unsigned long i,iMatches=0;
  int path=0,file=0;
  if(liga==NULL) return -2;
  if (lnkLinks==NULL) return -2;
  if(liga->ptrAddress==NULL) return -2;
//  if(liga->ptrAddress==NULL||liga->ptrPath==NULL) return -1;
  for(i=0;lnkLinks[i]!=NULL;i++) {
//    if(lnkLinks[i]->ptrAddress!=NULL&&lnkLinks[i]->ptrPath!=NULL)

    if(lnkLinks[i]->ptrAddress!=NULL) {
      if(!strcmp(lnkLinks[i]->ptrAddress,liga->ptrAddress)) {
        if(lnkLinks[i]->ptrPath==NULL&&liga->ptrPath==NULL) {
          path=1;
        } else {
          if(lnkLinks[i]->ptrPath!=NULL&&liga->ptrPath!=NULL) 
            if(!strcmp(lnkLinks[i]->ptrPath,liga->ptrPath)) path=1;
        }
        if(lnkLinks[i]->ptrFile==NULL&&liga->ptrFile==NULL) {
          file=1;
        } else {
          if(lnkLinks[i]->ptrFile!=NULL&&liga->ptrFile!=NULL)
            if(!strcmp(lnkLinks[i]->ptrFile,liga->ptrFile)) file=1;
        }
        if(path==1&&file==1&&iMatches>=iMatch) return i;
        path=file=0;
      }
    }
    
/*    if(!strcmp(lnkLinks[i]->ptrAddress,liga->ptrAddress)&&
       !strcmp(lnkLinks[i]->ptrPath,liga->ptrPath)) {
       if(lnkLinks[i]->ptrFile==NULL && liga->ptrFile==NULL) {
         if(iMatches>=iMatch) return i;
       }
       if(lnkLinks[i]->ptrFile!=NULL && liga->ptrFile!=NULL) 
         if(!strcmp(lnkLinks[i]->ptrFile,liga->ptrFile)) {
           if(iMatches>=iMatch) return i;
         }
    }
*/
  }
  return -1;
}

int fnCompLink(struct LINK *lnkLink1, struct LINK *lnkLink2)
{
  if(lnkLink2->ptrAddress==NULL||lnkLink2->ptrPath==NULL||
     lnkLink1->ptrAddress==NULL||lnkLink2->ptrPath==NULL  ) return 0;
  if(lnkLink1->ptrPath!=NULL&&lnkLink2->ptrPath!=NULL&&
     lnkLink1->ptrAddress!=NULL&&lnkLink2->ptrAddress!=NULL)
    if(!strcmp(lnkLink1->ptrAddress,lnkLink2->ptrAddress)&&
       !strcmp(lnkLink1->ptrPath,lnkLink2->ptrPath)) {
       if(lnkLink1->ptrFile==NULL && lnkLink2->ptrFile==NULL) {
         return 1;
       }
       if(lnkLink1->ptrFile!=NULL && lnkLink2->ptrFile!=NULL) 
         if(!strcmp(lnkLink1->ptrFile,lnkLink2->ptrFile)) {
           return 1;
         }
    }
  return 0;
}


struct LINK **fnLoadList(struct LINK **lnkLinks)
{
  FILE *fpArch;
  char strArch[2048];
  unsigned long i,lSize,n,r,c=0, flag=0;
  if(!QUIET) fprintf(stderr,"Leyendo lista\n");
  sprintf(strArch,"%s/%s_mir.list",lnkLinks[0]->ptrAddress,FIXNAMES2(lnkLinks[0]->ptrPath));
  if((fpArch=fopen(strArch,"rb"))==NULL) { perror("fopen"); return lnkLinks; }

  // Lee los datos de la estructura: tamanio<dato>tamanio<dato>
  for(n=0;lnkLinks[n]!=NULL;n++);  // Busca el primer espacio libre
  for(;;) { //n++) {
    c++;
    lnkLinks=(void *)realloc(lnkLinks,sizeof(void *)*(n+2));
    lnkLinks[n]=(struct LINK *)malloc(sizeof(struct LINK));
    lnkLinks[n+1]=NULL;
    // Lee la direccion
    if(fread((void *)&lSize,1,sizeof(unsigned long),fpArch)!=sizeof(unsigned long)) {
      if(lnkLinks[n]!=NULL) free(lnkLinks[n]);  // Pointer-loss approved ???
      lnkLinks[n]=NULL;
      fclose(fpArch);
      if(!QUIET) 
        fprintf(stderr,"%lu registros leidos, %lu eliminados por reptecion\n",c,(c-n));
      if(ptrAnterior!=NULL && ptrSiguiente!=NULL) {
        fnSaveList(lnkLinks);
        printf("Convertido el archivo\n");
        exit(0);
      }
      return lnkLinks;  
    }
    lnkLinks[n]->ptrAddress=(char *)malloc(lSize+2);
    bzero(lnkLinks[n]->ptrAddress,lSize+1);
    fread(lnkLinks[n]->ptrAddress,1,lSize,fpArch);
    lnkLinks[n]->ptrAddress[lSize]=0;
    // Lee el path
    fread((void *)&lSize,1,sizeof(unsigned long),fpArch);
    if(lSize==0) {
      lnkLinks[n]->ptrPath=(char *)malloc(1);
      strcpy(lnkLinks[n]->ptrPath,"");
    } else {
      lnkLinks[n]->ptrPath=(char *)malloc(lSize+2);
      bzero(lnkLinks[n]->ptrPath,lSize+1);
      fread(lnkLinks[n]->ptrPath,1,lSize,fpArch);
      lnkLinks[n]->ptrPath[lSize]=0;
    }
    
    // Aqui revisa si va a sustituir una parte del path por otra (para bajar
    // sitios con password que cambien su path cada vez que se accesan)
    if(ptrAnterior!=NULL && ptrSiguiente!=NULL) {
      char *ptrTMP=(char *)malloc(lSize+strlen(ptrSiguiente)+10);
      if(DEBUG>=2) printf("Voy a sustituir %s por %s\n",ptrAnterior, ptrSiguiente);
      if(strstr(lnkLinks[n]->ptrPath,ptrAnterior)!=NULL) {
        if(DEBUG>=2) printf("Cadena anterior: [%s]\n",lnkLinks[n]->ptrPath);
        bzero(ptrTMP,(lSize+strlen(ptrSiguiente)+10));
        strncpy(ptrTMP,lnkLinks[n]->ptrPath,
                 strstr(lnkLinks[n]->ptrPath,ptrAnterior)-lnkLinks[n]->ptrPath);
        strcat(ptrTMP,ptrSiguiente);
        strcat(ptrTMP,(lnkLinks[n]->ptrPath+strlen(ptrAnterior)));
        free(lnkLinks[n]->ptrPath);
        lnkLinks[n]->ptrPath=ptrTMP;
        if(DEBUG>=2) printf("Cadena siguiente: [%s]\n",lnkLinks[n]->ptrPath);
      }
      if(DEBUG>=3) getchar();
    }
    // Lee el archivo
    fread((void *)&lSize,1,sizeof(unsigned long),fpArch);
    if(lSize==0) 
      lnkLinks[n]->ptrFile=NULL;
    else {
      lnkLinks[n]->ptrFile=(char *)malloc(lSize+2);
      bzero(lnkLinks[n]->ptrFile,lSize+2);
      fread(lnkLinks[n]->ptrFile,1,lSize,fpArch);
      lnkLinks[n]->ptrFile[lSize]=0;
    }
    // Lee el tamanio
    fread((void *)&lnkLinks[n]->lSize,1,sizeof(unsigned long),fpArch);
    // Lee la posicion
    fread((void *)&lnkLinks[n]->lPos,1,sizeof(unsigned long),fpArch);
    // Lee el estatus
    fread((void *)&lnkLinks[n]->iStatus,1,sizeof(int),fpArch);
    if(!QUIET) if(!(c%512)) {
      fprintf(stderr,"Leidos %lu\x0d",n);
      fflush(stderr);
    }

    if(CHECKALL&&lnkLinks[n]->iStatus==BADLINK) {
      if(DEBUG>=3) printf("Deignorando http://%s/%s/%s\n",lnkLinks[n]->ptrAddress,
                                                          lnkLinks[n]->ptrPath,
                                                          lnkLinks[n]->ptrFile);
      lnkLinks[n]->iStatus=PENDENT;
    }
          
//  Elimina la primera ruta si es que ya existia
    if(fnCompLink(lnkLinks[0],lnkLinks[n])) {
      int t=n;
      n=0;
      if(lnkLinks[n]->ptrAddress!=NULL) free(lnkLinks[n]->ptrAddress);
      if(lnkLinks[n]->ptrPath!=NULL)    free(lnkLinks[n]->ptrPath);
      if(lnkLinks[n]->ptrFile!=NULL)    free(lnkLinks[n]->ptrFile);
      if(lnkLinks[n]!=NULL)             free(lnkLinks[n]);
      n=t;
      lnkLinks[0]=lnkLinks[n];
      flag=1;
    } 

    if(INITFILTER&&!flag) {
      if((r=fnSearchInDB(lnkLinks,lnkLinks[n],0))>=0) {
        if(r!=n) {
          if(lnkLinks[n]->ptrAddress!=NULL) free(lnkLinks[n]->ptrAddress);
          if(lnkLinks[n]->ptrPath!=NULL)    free(lnkLinks[n]->ptrPath);
          if(lnkLinks[n]->ptrFile!=NULL)    free(lnkLinks[n]->ptrFile);
          if(lnkLinks[n]!=NULL)             free(lnkLinks[n]);
        } else {
          lTotFiles++;
          if(lnkLinks[n]->iStatus==READY||lnkLinks[n]->iStatus==IGNORED) lDownFiles++;
          n++;
        }
      } else {
        lTotFiles++;
        if(lnkLinks[n]->iStatus==READY||lnkLinks[n]->iStatus==IGNORED) lDownFiles++;
        n++;
      }
    } else {
      if(lnkLinks[n]!=NULL) 
        if(fnCompLink(lnkLinks[0],lnkLinks[n])==0) {
          lTotFiles++;
          if(lnkLinks[n]->iStatus==READY||lnkLinks[n]->iStatus==IGNORED) lDownFiles++;
          n++;
        }
    }
  }
  fclose(fpArch);
  if(!QUIET) printf("%lu registros leidos, %lu eliminados por reptecion\n",c,n);
  if(ptrAnterior!=NULL && ptrSiguiente!=NULL) {
    fnSaveList(lnkLinks);
    printf("Convertido el archivo\n");
    exit(0);
  }
  return lnkLinks;
}

struct LINK **fnParse(struct LINK **lnkLinks, char *ptrFile, char *ptrCWD, struct LINK *lnkLiga)
{
  FILE *fpArch;
  char *ptrLink=NULL;
  char *ptrLinkRef[] = { "href", "src", NULL };
  char strPila[4096];
  char strRES[1024];
  struct LINK **oldlnkLinks=lnkLinks;
  int iRES=0;
  int iPila=0;
  int iLinkRef=0;
  int iLinkSize=0;
  int iC;
  int i,f,f2;
 
  // Este es usado para obtener codigos del webserver
  bzero(strRES,sizeof(strRES));
  
  if(!QUIET) printf("Buscando ligas en %s\n",ptrFile);
  
  if((fpArch=fopen(ptrFile,"rt"))==NULL) { perror("fopen"); return lnkLinks; }
  do {
    iC=Fgetc(fpArch);
    if(iC>=0) {
      // Revisa si trae caracteres de control, 
      if(iscntrl(iC)&&!isvalidhtmlchr(iC)&&ftell(fpArch)<32) {
        if(DEBUG>=1) printf("No es html %d\n",iC);
        fclose(fpArch);
        if(DEBUG>=3) getchar();
        return lnkLinks;
      }
      
      // Esto me sirve para obtener los codigos de error del webserver
      // 403 = Forbidden
      // 404 = Not Found
      // Access Denied
      // Unknown Resource
      strRES[iRES]=iC;
      iRES++;
      if(iRES>sizeof(strRES)) {
        iRES=sizeof(strRES);
        strcpy(strRES,(char *)&strRES[1]);
      }
      strRES[sizeof(strRES)-1]=0;
      if(!strncmp(strRES,"404 Not Found",13)||
         !strncmp(strRES,"403 Forbidden",13)||
         !strncmp(strRES,"Access Denied",13)||
         !strncmp(strRES,"Unknown Resource",16)) {
         strRES[13]=0;
         if(!QUIET)
           printf("Errores (1) en la pagina <%s/%s>: [%s]\n",ptrCWD,ptrFile,strRES);
         if(DEBUG>=3) getchar();
         fclose(fpArch);
         lnkLiga->iStatus=BADLINK;
         unlink(ptrFile);
         return oldlnkLinks;
      }
    }
  } while(iC>=0);

  fclose(fpArch);   
  if((fpArch=fopen(ptrFile,"rt"))==NULL) { perror("fopen"); return lnkLinks; }
  do {
    iC=Fgetc(fpArch);
    if(iC>=0) {
      // Revisa si trae caracteres de control, 
      if(iscntrl(iC)&&!isvalidhtmlchr(iC)&&ftell(fpArch)<32) {
        if(DEBUG>=1) printf("No es html %d\n",iC);
        fclose(fpArch);
        if(DEBUG>=3) getchar();
        return lnkLinks;
      }
      
      // Esto me sirve para obtener los codigos de error del webserver
      // 403 = Forbidden
      // 404 = Not Found
      // Access Denied
      // Unknown Resource
      strRES[iRES]=iC;
      iRES++;
      if(iRES>sizeof(strRES)) {
        iRES=sizeof(strRES);
        strcpy(strRES,(char *)&strRES[1]);
      }
      strRES[sizeof(strRES)-1]=0;
      if(!strncmp(strRES,"404 Not Found",13)||
         !strncmp(strRES,"403 Forbidden",13)||
         !strncmp(strRES,"Access Denied",13)||
         !strncmp(strRES,"Unknown Resource",16)) {
         strRES[13]=0;
         if(!QUIET)
           printf("Errores en la pagina <%s/%s>: [%s]\n",ptrCWD,ptrFile,strRES);
         if(DEBUG>=3) getchar();
         fclose(fpArch);
         lnkLiga->iStatus=BADLINK;
         unlink(ptrFile);
         return oldlnkLinks;
      }
      
      // Revisa si es un tag de html
      if(iC=='<') {
        if(DEBUG>=2) printf("\x1b[27;0;31;40m");
        fflush(stdout);
        // Revisa hasta encontrar algun tag valido de liga o imagen
        while((iC=Fgetc(fpArch))>=0) {
          switch(iC) {
            case '"': 
            case 39: // es la '
              if(iPila==0) {
                if(DEBUG>=2) printf("\x1b[27;0;%d;40m",32+iPila);
                strPila[iPila++]=iC;
              } else {
                if(strPila[iPila-1]==iC) {
                  iPila--; 
                  if(iPila>0)
                    if(DEBUG>=2) printf("\x08\x1b[27;0;%d;40m%c",32+iPila,iC);
                  else
                    if(DEBUG>=2) printf("\x08\x1b[27;0;31;40m%c",iC);
                } else {
                  strPila[iPila++]=iC;
                  if(DEBUG>=2) printf("\x1b[27;0;%d;40m",32+iPila);
                }
              }
              break;
            default: 
              if(f==0||f==1)
              for(i=f=0; ptrLinkRef[i]!=NULL&&f!=2; i++) {
                // Busco el tag siempre y cuando no este dentro de unas comillas
                if(tolower(ptrLinkRef[i][iLinkRef])==tolower(iC)&&iPila==0) {
                  f=1;
                  // Aqui ya encontre un tag adecuado
                  if(ptrLinkRef[i][iLinkRef+1]==0) { f=2; break; } // medisoft
                }
              }
              if(f==0) iLinkRef=0;
              if(f==1) iLinkRef++;
              if(f==2) {
                if(DEBUG>=2) printf("\x1b[27;1;31;40mEncontre el tag %s\x1b[27;0;31;40m\n",ptrLinkRef[i]);
                // Ya encontre el tag, ahora busco un = para ver donde comienza
                while((iC=Fgetc(fpArch))>=0) if(iC=='=') break; 
                // Ahora busco lo primero que sea diferente de espacio
                while((iC=Fgetc(fpArch))>=0) if(iC!=' ') { ungetc(iC,fpArch); putchar(8); break; }
                f2=0;
                // Ahora extraigo la cadena
                while((iC=Fgetc(fpArch))>=0) {
                  switch(iC) {
                    case '"': 
                    case 39: // es la '
                      if(iPila==0) {
                        if(DEBUG>=2) printf("\x1b[27;1;%d;40m",32+iPila);
                        strPila[iPila++]=iC;
                        f2=1;
                      } else {
                        if(strPila[iPila-1]==iC) {
                          iPila--; 
                          if(iPila>0) {
                            if(DEBUG>=2) printf("\x08\x1b[27;1;%d;40m%c",32+iPila,iC);
                          } else {
                            if(DEBUG>=2) printf("\x08\x1b[27;0;31;40m%c",iC);
                            break;
                          }
                        } else {
                          f2=1;
                          strPila[iPila++]=iC;
                          if(DEBUG>=2) printf("\x1b[27;1;%d;40m",32+iPila);
                        }
                      }
                      break;
                    default: 
                      if((iC==' '||iC=='>')&&!iPila || (f2&!iPila)) break;
                      ptrLink=(char *)realloc(ptrLink,iLinkSize+2);
                      ptrLink[iLinkSize++]=iC;
                      ptrLink[iLinkSize]=0;
                  }    
                  if((iC==' '||iC=='>')&&!iPila) break;
                }
              }
          }
          if(((iC==' '&&f==2)||iC=='>')&&!iPila) {
            if(DEBUG>=2) printf("\x08\x1b[27;0;37;40m>");
            fflush(stdout);
            if(iLinkSize>0&&f==2) {
              if(DEBUG>=1) printf("\nObtuve [%s]\n",ptrLink);
//              if(!strcmp(ptrLink,"/")) obtuvo=1;
              lnkLinks=fnAddLinkToList(lnkLinks,ptrLink,ptrCWD);
              if(DEBUG>=3)
              if(getchar()=='1') {
                printf("ILS=%d, F=%d, ptrLNK=%s\n",iLinkSize,f,ptrLink);
              }
            }
//          if(ptrLink!=NULL) free(ptrLink);  // Pointer-loss approved ???
            ptrLink=NULL;
            iLinkSize=iLinkRef=0;
            f=0;
            break;
          }
        }
      }
    }
  } while(iC>=0);
  
  fclose(fpArch);
  if(DEBUG>=3)
  for(i=0;lnkLinks[i]!=NULL;i++) {
      printf("Ligas [%s]/[%s]",lnkLinks[i]->ptrAddress,
              lnkLinks[i]->ptrPath);
      if(lnkLinks[i]->ptrFile==NULL) {
        printf("\n");
      } else {
        printf("/[%s]\n",lnkLinks[i]->ptrFile);
      }
  }
  return lnkLinks;
}

struct LINK **fnDownload(struct LINK **lnkLinks, struct LINK *lnkLiga)
{
  char cmd[8192];
  char tmpfile[8192], errtmp[8192], tmpbuf[5];
  FILE *fpCmd, *fpArch;
  FILE *oldstderr=stderr, *fpTmp;
  int iC,i,iTout;
  long lZero=0;
  time_t tout;
  if(LYNXOK)
    sprintf(errtmp,"/tmp/mir.tmp");
  else
    sprintf(errtmp,"%s/Lynx.trace",getenv("HOME"));
redownload:;
  if(DEBUG>=1) printf("iSTATUS %d\n",lnkLiga->iStatus);
  
  while(lnkLiga->ptrPath[0]=='/') 
    strcpy(lnkLiga->ptrPath,(char *)&lnkLiga->ptrPath[1]);

  if(lnkLiga->ptrFile!=NULL)
  while(lnkLiga->ptrFile[0]=='/') 
    strcpy(lnkLiga->ptrFile,(char *)&lnkLiga->ptrFile[1]);
  
  // Crea el comando de lynx para bajar el archivo
  if(USER[0] && PASS[0]) 
    sprintf(cmd,"lynx -trace -auth=%s:%s -source \x22http://%s/%s",USER,PASS,lnkLiga->ptrAddress,
                                                lnkLiga->ptrPath);
  else                                            
    sprintf(cmd,"lynx -trace -source \x22http://%s/%s",lnkLiga->ptrAddress,
                                                lnkLiga->ptrPath);
  if(lnkLiga->ptrFile==NULL) {
    if(cmd[strlen(cmd)-1]!='/') strcat(cmd,"/");
    strcat(cmd,"\x22");
  } else {
    if(cmd[strlen(cmd)-1]!='/') strcat(cmd,"/");
    strcat(cmd,lnkLiga->ptrFile);
    strcat(cmd,"\x22");
  }
  if(LYNXOK) {
    strcat(cmd," 2> ");
    strcat(cmd,errtmp);
  }
  // Se asegura que solo sean caracteres validos si se especifico ONLYASCII
  if(ONLYASCII)
    for(i=0;i<strlen(cmd);i++) 
      if(cmd[i]<32) { if(DEBUG>=2) printf("[%s]<32\n",cmd); return lnkLinks; }
  
  // Corre el comando para bajar el archivo
  if(DEBUG>=1) printf("CMD: [%s]\n",cmd);
  unlink(errtmp);
  if((fpCmd=popen(cmd,"rb"))==NULL) { perror("popen"); return lnkLinks; }
  iTout=0;
  while(!fnGetSize(errtmp)&&iTout<300) sleep(1),iTout++; 
  if(fnGetSize(errtmp)==-1||iTout>=300) {
    pclose(fpCmd);
    goto redownload;
  }
  lnkLiga->lSize=fnGetSize(errtmp);
  if(lnkLiga->ptrFile==NULL) {
    sprintf(tmpfile,"%s/%s",lnkLiga->ptrAddress, lnkLiga->ptrPath);
    MKDIR(tmpfile);
    if(tmpfile[strlen(tmpfile)-1]!='/') strcat(tmpfile,"/");
    strcat(tmpfile,"index.html");
    if((fpArch=fopen(tmpfile,"wb"))==NULL) { perror("fopen"); pclose(fpCmd); return lnkLinks; }
  } else {
    sprintf(tmpfile,"%s/%s",lnkLiga->ptrAddress, lnkLiga->ptrPath);
    MKDIR(tmpfile);
    if(tmpfile[strlen(tmpfile)-1]!='/') strcat(tmpfile,"/");
    strcat(tmpfile,lnkLiga->ptrFile);
    if((fpArch=fopen(tmpfile,"wb"))==NULL) { perror("fopen"); pclose(fpCmd); return lnkLinks; }
  }
  tout=time(NULL);
  do {
    signal(SIGALRM,(void *)_ALARMA);
    alarm(60);
    iC=fgetc(fpCmd);
    if(iC>=0) {
      if(fputc(iC,fpArch)!=iC) {
        perror("fputc:diskfull");
        exit(0);
      }
      tout=time(NULL);
    }
    if(!(ftell(fpArch)%512)) {
      lnkLiga->lSize=fnGetSize(errtmp);
      if(!QUIET) {
        // Pone el color, rojo, amarillo, verde, blanco brillante
        if((ftell(fpArch)*100/(lnkLiga->lSize?lnkLiga->lSize:1))<25)
          printf("\x1b[27;1;31;40m"), fflush(stdout);
        else if((ftell(fpArch)*100/(lnkLiga->lSize?lnkLiga->lSize:1))<50)
          printf("\x1b[27;1;33;40m"), fflush(stdout);
        else if((ftell(fpArch)*100/(lnkLiga->lSize?lnkLiga->lSize:1))<75)
          printf("\x1b[27;1;32;40m"), fflush(stdout);
        else printf("\x1b[27;1;37;40m"), fflush(stdout);

        printf("%lu\x1b[27;0;37;40m/%lu bytes bajados (%lu de %lu archivos bajados)\x0d",
                                                    ftell(fpArch),
                                                    lnkLiga->lSize,lDownFiles,lTotFiles);
        fflush(stdout);
      }
    }
  } while(iC>=0);
  signal(SIGALRM,SIG_IGN);
  alarm(0);
  // Pone en la liga del archivo que acaba de bajar el tamanio que tuvo, que 
  // no forzosamente es el tamanio real, me falta determinar como obtener
  // el tamanio real y como continar archivos por http
  lnkLiga->lPos=ftell(fpArch);
  lnkLiga->lSize=fnGetSize(errtmp);
  unlink(errtmp);
  if(!QUIET) 
    printf("\x0d%s%lu%s/%lu bytes bajados (%lu de %lu archivos bajados)\n",
      (lnkLiga->lPos - lnkLiga->lSize)?"\x1b[27;1;31;40m":"",
      ftell(fpArch),
      (lnkLiga->lPos - lnkLiga->lSize)?"\x1b[27;0;37;40m":"",
      lnkLiga->lSize,lDownFiles,lTotFiles);
      
  if(pclose(fpCmd)!=0||(time(NULL)-tout)>55||lnkLiga->lPos<5||lnkLiga->lPos<lnkLiga->lSize) {
    //if(DEBUG>=1) printf("No pude bajar el archivo, lo bajo despues\n");
    if(DEBUG>=3) getchar();
    if(lnkLiga->lPos<lnkLiga->lSize||lnkLiga->lSize==0) lnkLiga->iStatus=UNFINISH;
    if(lnkLiga->lSize==0) lZero++;
  } else {
    lnkLiga->iStatus=READY;
    lDownFiles++;
  }
  fclose(fpArch);
  if(lZero>MAXBAD&&lnkLiga->lSize==0) {
    if(!QUIET) printf("Esta liga esta mal, marco como BADLINK\n");
    unlink(tmpfile), lnkLiga->iStatus=BADLINK;
  }
  if(lnkLiga->iStatus==UNFINISH) goto redownload;
  
  // Extrae todas las ligas que haya en este documento
  if(!(lZero>MAXBAD&&lnkLiga->lSize==0))
    lnkLinks=fnParse(lnkLinks, tmpfile, lnkLiga->ptrPath, lnkLiga);
  if(DEBUG>=1) printf("STATUS %d\n",lnkLiga->iStatus);
  if(PAUSA) {
    int i;
    for(i=0;i<PAUSA;i++) {
      if(!QUIET) {
        printf("Pausando %d segundos    \x0d",PAUSA-i);
        fflush(stdout);
      }
      sleep(1);
    }
    if(!QUIET) printf("\n");
  }
  return lnkLinks;
}



struct LINK **fnRebuild(struct LINK **lnkLinks)
{
  char tmpfile[8192];
  struct LINK *lnkLiga;
  unsigned long i,rb=0,ab=0;
  struct stat st_buf;
  
  if(!QUIET) printf("Revisando la existencia de los archivos...\n");
  
  // Checa campo por campo si el archivo existe o no, y si existe cual
  // es su tamanio
  for(i=0;lnkLinks[i]!=NULL;i++) {
    lnkLiga=lnkLinks[i];
    bzero(tmpfile,sizeof(tmpfile));
    if(lnkLiga->ptrFile==NULL) {
      sprintf(tmpfile,"%s/%s",lnkLiga->ptrAddress, lnkLiga->ptrPath);
      if(tmpfile[strlen(tmpfile)-1]!='/') strcat(tmpfile,"/");
      strcat(tmpfile,"index.html");
    } else {
      sprintf(tmpfile,"%s/%s",lnkLiga->ptrAddress, lnkLiga->ptrPath);
      if(tmpfile[strlen(tmpfile)-1]!='/') strcat(tmpfile,"/");
      strcat(tmpfile,lnkLiga->ptrFile);
    }
    //printf("Revisando %s %lu %s\n",tmpfile,lnkLiga->lSize,lnkLiga->ptrFile);
    if(stat(tmpfile,(struct stat *)&st_buf)==-1) {
      unsigned long lLink=i;

//        if(!QUIET) printf("Aadiendo %s (%lu/%lu)???\n",tmpfile,lnkLiga->lPos,lnkLiga->lSize);

      if(!strncmp(lnkLinks[0]->ptrPath,lnkLinks[lLink]->ptrPath,strlen(lnkLinks[0]->ptrPath))||!RESTRICTDIR)
       if(!strcmp(lnkLinks[0]->ptrAddress,lnkLinks[lLink]->ptrAddress)||!RESTRICTSITE)
        if(!fnExclude(lnkLinks,lLink)) {

      if(lnkLiga->iStatus==READY||lnkLiga->iStatus==IGNORED) {
        lDownFiles--, rb++;
        if(!QUIET) printf("Aadiendo %s (%lu/%lu)\n",tmpfile,lnkLiga->lPos,lnkLiga->lSize);
      }
      if(lnkLiga->iStatus!=BADLINK) lnkLiga->iStatus=PENDENT;
      }
    } else {
      lnkLiga->lPos=st_buf.st_size;
      if(lnkLiga->lPos==0) printf("Obtuve %s\n",tmpfile);
      if((lnkLiga->lPos==0||lnkLiga->lPos!=lnkLiga->lSize)) { 
        if(lnkLiga->iStatus==READY) {
          lDownFiles--, rb++;
          lnkLiga->iStatus=PENDENT;
          if(lnkLiga->lPos<lnkLiga->lSize) lnkLiga->iStatus=UNFINISH;
          if(!QUIET) printf("Aadiendo %s (%lu/%lu)\n",tmpfile,lnkLiga->lPos,lnkLiga->lSize);
        }
      } else { 
        if(lnkLiga->iStatus!=READY&&lnkLiga->lSize==lnkLiga->lPos&&lnkLiga->lSize>0) {
          if(lnkLiga->iStatus!=BADLINK) lnkLiga->iStatus=READY;
          ab++;
          if(!QUIET) printf("Retiro %s (%lu/%lu)\n",tmpfile,lnkLiga->lPos,lnkLiga->lSize);
        } else lnkLiga->lSize=lnkLiga->lPos;
      }
    }
    if(DEBUG>=2) {
      if(!(i%100)) {
        printf("%lu archivos de %lu\x0d",i,lTotFiles);
        fflush(stdout);
      }
    }
  }
  //if(DEBUG>=2) 
  printf("%lu archivos de %lu, %lu reaadidos, %lu retirados\n",i,lTotFiles,rb,ab);
  if(!QUIET) printf("Revisados\n");
  return lnkLinks;
}

int fnExclude(struct LINK **lnkLinks, unsigned long lLink)
{
  int i;
  char cmd[8192];
  char cmp[8192];
  
  // Crea la linea completa para revisar si la excluyo o no
  sprintf(cmd,"http://%s/%s",lnkLinks[lLink]->ptrAddress,
                             lnkLinks[lLink]->ptrPath);
  if(lnkLinks[lLink]->ptrFile==NULL) {
    if(cmd[strlen(cmd)-1]!='/') strcat(cmd,"/");
  } else {
    if(cmd[strlen(cmd)-1]!='/') strcat(cmd,"/");
    strcat(cmd,lnkLinks[lLink]->ptrFile);
  }
  if(ptrExcludeList!=NULL)
  for(i=0;ptrExcludeList[i]!=NULL&&cmd!=NULL;i++)
    if(strstr(cmd,ptrExcludeList[i])!=NULL) return 1; 
  for(i=0;i<strlen(cmd);i++) if(cmd[i]<32) return 1;
  return 0;
}
void fnStart(struct LINK **lnkLinks)
{
  unsigned long lLink=0;
  srandom(time(NULL));
  srand(time(NULL));
  printf("Iniciando downloading...\n");
  // Inicia a bajar los archivos
  while(lnkLinks[lLink]!=NULL) {
    if(lnkLinks[lLink]->iStatus!=READY&&lnkLinks[lLink]->iStatus!=IGNORED&&
       lnkLinks[lLink]->iStatus!=BADLINK) {
// aqui iba
      
      // Baja el documento/archivo de datos, si esta dentro de el mismo site
      // y del mismo directorio, y excluye los archivos/directorios que se
      // hayan indicado al principio
      if(!strncmp(lnkLinks[0]->ptrPath,lnkLinks[lLink]->ptrPath,strlen(lnkLinks[0]->ptrPath))||!RESTRICTDIR)
       if(!strcmp(lnkLinks[0]->ptrAddress,lnkLinks[lLink]->ptrAddress)||!RESTRICTSITE)
        if(!fnExclude(lnkLinks,lLink))  {
// Temporal
      fnSaveList(lnkLinks);
      if(!QUIET) {
        printf("Bajando [%s]/[%s]",lnkLinks[lLink]->ptrAddress,
                lnkLinks[lLink]->ptrPath);
        if(lnkLinks[lLink]->ptrFile==NULL) {
          printf("\n");
        } else {
          if(haveascii(lnkLinks[lLink]->ptrFile))
            printf("\n");
          else
            printf("/[%s]\n",lnkLinks[lLink]->ptrFile);
        }
      }
// Termina Temporal      
         lnkLinks=fnDownload(lnkLinks, lnkLinks[lLink]);
        } else
         lnkLinks[lLink]->iStatus=IGNORED, lDownFiles++;
       else
        lnkLinks[lLink]->iStatus=IGNORED, lDownFiles++;
      else
       lnkLinks[lLink]->iStatus=IGNORED, lDownFiles++;
    }
    if(!RANDOM) lLink++; else {
      if(DEBUG>=2) printf("hay %lu archivos %lu\n",lTotFiles,RAND_MAX);
      do {
        lLink=(unsigned long) random()*lTotFiles;
        while(lLink>lTotFiles) {
          lLink/=3;
          if(lLink<=0) lLink=(unsigned long) random()*lTotFiles;
        }
        if(DEBUG>=2) printf("%lu\n",lLink);
        if(DEBUG>=3) getchar();
      } while(lLink>lTotFiles||lnkLinks[lLink]==NULL||lnkLinks[lLink]->iStatus==READY||lnkLinks[lLink]->iStatus==IGNORED);
      if(DEBUG>=2) printf("Bajando la liga %lu\n",lLink);
    }
  }
  fnSaveList(lnkLinks);
  printf("Downloading terminado, %lu archivos de %lu bajados\n",lDownFiles,lTotFiles);
}

void fnGetParams(int argc, char **argv)
{
  int i,x=0;
  bzero(USER,sizeof(USER));
  bzero(PASS,sizeof(PASS));
  ptrExcludeList=(void *)malloc(sizeof(void *)*(argc+2));
  ptrAnterior=ptrSiguiente=NULL;
  for(i=2;i<argc;i++) {
    if(!strcmp(argv[i],"-q")) QUIET=1; else
    if(!strcmp(argv[i],"-d")) {
      if(argc>(i+1)) DEBUG=atoi(argv[++i]); else printf("Error en parametro -d\n");
    } else
    if(!strcmp(argv[i],"-x")) {
      do {
        ptrExcludeList[x]=argv[++i];
        if(ptrExcludeList[x]==NULL||i>=argc) {
          printf("Error en parametro -x\n");
          exit(1);
        }
        if(ptrExcludeList[x][strlen(ptrExcludeList[x])-1]==',') {
          ptrExcludeList[x][strlen(ptrExcludeList[x])-1]=0;
          x++;
        } else break;
      } while(i<argc);
      ptrExcludeList[++x]=NULL;
    } else 
    if(!strcmp(argv[i],"-c")) {
      ptrAnterior=argv[++i];
      if(i+1>argc||argv[i+1]==NULL) {
        ptrSiguiente=(char *)malloc(2);
        bzero(ptrSiguiente,2);
      } else {
        ptrSiguiente=argv[++i];
      }
    } else 
    if(!strcmp(argv[i],"-p")) {
      PAUSA=atoi(argv[++i]);
    } else 
    if(!strcmp(argv[i],"-rs")) {
      RESTRICTSITE=0;
    } else 
    if(!strcmp(argv[i],"-rd")) {
      RESTRICTDIR=0;
    } else 
    if(!strcmp(argv[i],"-u")) {
      strcpy(USER,argv[++i]);
      strcpy(PASS,argv[++i]);
    } else 
    if(!strcmp(argv[i],"-rebuild")) {
      REBUILD=1;
    } else
    if(!strcmp(argv[i],"-noinitfilter")) {
      INITFILTER=0;
    } else
    if(!strcmp(argv[i],"-random")) {
      RANDOM=1;
    } else
    if(!strcmp(argv[i],"-checkall")) {
      CHECKALL=1;
    } else
    if(!strcmp(argv[i],"-export")) {
      EXPORT=1;
    } else
    if(!strcmp(argv[i],"-import")) {
      EXPORT=2;
    } else
    if(!strcmp(argv[i],"-badlynx")) {
      LYNXOK=0;
    } else {
      printf("Error en parametros, teclea \x22mir\x22 para ayuda\n");
      exit(1);
    }
  }
  if(x) {
  for(i=0;ptrExcludeList[i]!=NULL;i++) 
    printf("Excluyo: [%s]\n",ptrExcludeList[i]);
  } else {
    ptrExcludeList=NULL;
  }
}

int main(int argc, char **argv)
{
  struct LINK **lnkLinks=NULL, **lnkOld;
  char *ptrInitLink;
  
  lTotFiles=lDownFiles=0;
  
  fprintf(stderr,"Mir %s, Mario Medina Software, 1988-99  GNU Software\n",VERSION);
  if(argc<2) {
    fprintf(stderr,"No me dijiste la liga inicial\n");
    fprintf(stderr,"Parametros: <liga> [-q][-d <0-3>][-x <path/file>, <path1/file1>, ...]\n");
    fprintf(stderr,"            [-c <parte anterior del path> <parte siguiente del path>]\n");
    fprintf(stderr,"            [-p <segundos de pausa entre cada download>]\n");
    fprintf(stderr,"            [-rs <NO restringe a solo este sitio>]\n"
           "            [-rd <NO restringe a solo este directorio>]\n"
           "            [-rebuild] Reconstruye la base de datos usando lo directorios\n"
           "            [-u <user> <password>]\n"
           "            [-random] No baja de forma secuencial, sino aleatoria\n"
           "            [-noinitfilter] NO revisa duplicados al cargar la lista\n"
           "            [-badlynx] Usa el archivo ~/Lynx.trace a fuerzas (para RH)\n"
           "            [-import] Lee de STDIN la lista de direcciones en el formato\n"
           "                      generado por -export, y los agrega a la base de datos\n"
           "            [-export] Imprime a STDOUT la lista de ligas que hay en la \n"
           "                      base de datos\n"
           "            [-checkall] Vuelve a intentar todas las ligas marcadas como malas\n");
    exit(0);
  }
  LYNXOK=fnTestLynx();
  fnGetParams(argc, argv);

  if(EXPORT==1) {
    ptrInitLink=argv[1];
    lnkLinks=fnGetMainAddress(NULL, ptrInitLink);
    lnkLinks=fnLoadList(lnkLinks); 
    fnExport(lnkLinks);
    exit(0);
  } else if(EXPORT==2) {
    ptrInitLink=argv[1];
    lnkLinks=fnGetMainAddress(NULL, ptrInitLink);
    lnkLinks=fnImport(lnkLinks);
    fnSaveList(lnkLinks);
    exit(0);
  }
  ptrInitLink=argv[1];
  lnkLinks=fnGetMainAddress(NULL, ptrInitLink);
  lnkOld=lnkLinks;


  lnkLinks=fnLoadList(lnkLinks); 
  if(lnkOld!=lnkLinks) {
    if(fnSearchInDB(lnkLinks,lnkLinks[0],1)==0) {
      lnkLinks[0]->iStatus=READY;
      if(DEBUG>=1) printf("No leo el primer documento, ya lo habia leido\n");
    }
  }
  if(!QUIET) printf("MainAddress [%s]\n",lnkLinks[0]->ptrAddress);
  if(!QUIET) printf("MainPath [%s]\n",lnkLinks[0]->ptrPath);
  if(lnkLinks[0]->ptrFile!=NULL)
    if(!QUIET) printf("MainFile [%s]\n",lnkLinks[0]->ptrFile);
  if(REBUILD) {
    lnkLinks=fnRebuild(lnkLinks);
    fnSaveList(lnkLinks);   
    if(DEBUG>=3) getchar();
  }
  signal(SIGTERM,(void *)Terminar);
  signal(SIGINT,(void *)Terminar);
  fnStart(lnkLinks);
  return 0;
}

unsigned long dir_INET(hostName)
char *hostName;
{
   struct hostent* hostStruct;
   struct in_addr* hostNode;
   if(DEBUG>=2) printf("Localizando IP de %s...",hostName);
   hostStruct=gethostbyname(hostName);
   if (hostStruct==NULL)
        {
        printf("\nNo existe el IP\n");
        exit(-1);
        }
   hostNode=(struct in_addr*) hostStruct->h_addr;
   if(DEBUG>=2) printf("%s\n",inet_ntoa(*hostNode));
   return (hostNode->s_addr); 
}


/*
unsigned long fnGetSize(struct LINK **lnkLinks, struct LINK *lnkLiga)
{
  char link[512],cmd[768];
  struct sockaddr_in sockname;
  int sock,iLength=0,iGetSize=0;
  unsigned long lSize=0;
  
  sprintf(link,"http://%s",lnkLiga->ptrAddress);
  
  if(lnkLiga->ptrPath!=NULL)
    if(strlen(lnkLiga->ptrPath)>0) {
      strcat(link,"/");
      strcat(link,lnkLiga->ptrPath);
    }
    
  if(lnkLiga->ptrFile!=NULL)
    if(strlen(lnkLiga->ptrFile)>0) {
      strcat(link,"/");
      strcat(link,lnkLiga->ptrFile);
    }
    
  if(DEBUG>=2) printf("Obteniendo tamanio de [%s]\n",link);
  
  // Creando el socket
  if((sock=socket(AF_INET, SOCK_STREAM, 0))==-1) {
    perror("SOCKET");
    return 0;
  }
  sockname.sin_family=AF_INET;
  sockname.sin_addr.s_addr=dir_INET(lnkLiga->ptrAddress);
  sockname.sin_port=htons(80);
  if(connect(sock,(struct sockaddr *)&sockname, sizeof(sockname))==-1) {
    perror("CONNECT");
    return 0;
  }
  sprintf(cmd,"GET %s HTTP/1.0\n\n",link);
  write(sock,cmd,strlen(cmd));
  while(read(sock,link,1)==1&&!iGetSize) {
    if(link[0]!=13&&link[0]!=10) 
      cmd[iLength++]=tolower(link[0]);
    else {
      cmd[iLength]=0;
      if(DEBUG>=2) printf("Linea: %s\n",cmd);
      iLength=0;
      if(!strncmp(cmd,"content-length:",15)) 
        lSize=atol((char *)&cmd[16]), iGetSize=1;
    }
  }
  close(sock);
  if(DEBUG>=2) printf("Tamanio(a) es %lu\n",lSize);
  if(DEBUG>=2) getchar();
  return lSize;
}
*/

long fnGetSize(char *src)
{
  char link[512], cmd[768];
  int iLength=0,iGetSize=0,iTout=5,iRep=3;
  unsigned long lSize=0, tSize=0,l1,l2;
  time_t t_Tout;
  char str1[256],str2[256],str3[256];
  FILE *fp;
  if(DEBUG>=3) printf("Revisando archivo %s\n",src);
  do {
    if(!iTout&&!iGetSize&&iRep) fclose(fp), iTout=5;
    iRep--;
    while((fp=fopen(src,"rw"))==NULL) {
      sleep(1);
      return 0;
    }
    t_Tout=time(NULL);
    while((link[0]=fgetc(fp))!=EOF&&iTout) {
      if(t_Tout!=time(NULL)) iTout--, t_Tout=time(NULL);
//      if(DEBUG>=3) printf("iTout %d iRep %d\n",iTout,iRep);
      if(link[0]!=13&&link[0]!=10) {
        cmd[iLength++]=tolower(link[0]);
      } else {
        cmd[iLength]=0;
        if(DEBUG>=3) printf("Linea: %s\n",cmd);
        iLength=0;
        if(!strncmp(cmd,"content-length:",15)) 
          lSize=atol((char *)&cmd[16]); 
        if(!strncmp(cmd,"alert!: unexpected network read error",37)) {
          fclose(fp);
          if(!QUIET) printf("Error: la red no funciono bien\n");
          return -1;
        }
      }
    }
  } while(iRep&&!iTout);
  if(!iTout) {
    fclose(fp);
    if(!QUIET) printf("Error: no pude revisar el tamao\n");
    return -1;
  }
  iTout=5;
  iGetSize=0;
  rewind(fp);
  while((link[0]=fgetc(fp))!=EOF&&!iGetSize) {
    if(link[0]!=13&&link[0]!=10) 
      cmd[iLength++]=tolower(link[0]);
    else {
      cmd[iLength]=0;
      if(DEBUG>=3) printf("Linea: %s\n",cmd);
      iLength=0;
      if(!strncmp(cmd,"content-length:",15)) 
        lSize=atol((char *)&cmd[16]); 
      if(!strncmp(cmd,"alert!: unexpected network read error",37)) {
        fclose(fp);
        if(!QUIET) printf("Error: la red no funciono bien\n");
        return -1;
      }
      if(!strncmp("data transfer complete",cmd,22)) {
        if(lSize==0&&l1!=0) lSize=l1;
        if(lSize==0&&l2!=0) lSize=l2;
      }
      sscanf(cmd,"%s%lu%s%lu%s",str1,&l1,str2,&l2,str3);
      if(!strcmp(str1,"read")&&!strcmp(str2,"of")&&l2!=lSize&&
         strcmp(str3,"kb")&&l2!=0) lSize=l2;
    }
  }

  if(DEBUG>=3) printf("Tamanio(b) es %lu\n",lSize);
  fclose(fp);
  if(lSize==0) sleep(1);
  return lSize;
}

int fnTestLynx(void)
{
  FILE *fp;
  char tmpfile[8192];
  struct stat st_buf;
  sprintf(tmpfile,"%s/Lynx.trace",getenv("HOME"));
  if(!QUIET) fprintf(stderr,"Revisando si es lynx default o no: "), fflush(stdout);
  if((fp=popen("lynx -trace -dump http://localhost 1> /dev/null 2> /tmp/mir.test","r"))==NULL) return 0;
  sleep(5);
  pclose(fp);
  if(stat("/tmp/mir.test",&st_buf)==-1) {
    if(!QUIET) fprintf(stderr,"Lynx no comun\n");
    unlink(tmpfile);
    unlink("/tmp/mir.test");
    return 0;
  }
  if(!st_buf.st_size) {
    if(!QUIET) fprintf(stderr, "Lynx no comun\n");
    unlink(tmpfile);
    unlink("/tmp/mir.test");
    return 0;
  }
  if(!QUIET) fprintf(stderr,"Lynx OK\n");
  unlink(tmpfile);
  unlink("/tmp/mir.test");
  return 1;
}